Welcome to the IoT.js!

> IoT.js is a framework for "Internet of Things" built on
> lightweight JavaScript interpreter ['JerryScript'](https://github.com/jerryscript-project/jerryscript)
> and libtuv for event driven(non-blocking I/O model) similar to node.js.

### IoT.js Wiki

**About**
- [License](License.md)
- [Governance](contributing/Governance.md)

**[Getting Started](Getting-Started.md)**
- [x86 / Linux](build/Build-for-x86-Linux.md)
- [Raspberry Pi 2 / Linux](build/Build-for-RPi2-Linux.md)
- [Raspberry Pi 3 / Tizen](build/Build-for-RPi3-Tizen.md)
- [Stm32f4 / NuttX](build/Build-for-STM32F4-NuttX.md)
- [ARTIK053 / TizenRT](build/Build-for-ARTIK053-TizenRT.md)

**[Developer Guide](Developer's-Guide.md)**
- [Development Process](devs/Development-Process.md)
- [Certificate of Origin](devs/IoT.js-Developer's-Certificate-of-Origin-1.0.md)
- [Test Guidelines](devs/Test-Guidelines.md)
- [Coding Style Guidelines](devs/Coding-Style-Guidelines.md)
- [API Document Guidelines](devs/API-Document-Guidelines.md)
- [Developer Tutorial](devs/Developer-Tutorial.md)
- [Advanced Development](devs/Advanced-Development.md)
- [IoT.js API Reference](api/IoT.js-API-reference.md)

**Contributing**
- [Patch Submission Process](contributing/Patch-Submission-Process.md)
- [Community Guideline](contributing/Community-Guidelines.md)
- [Assigned People](contributing/Assigned-People.md)
